// isp_test.c

#include <stdio.h>
#include "pico/stdlib.h"
#include "pico/binary_info.h"
#include "hardware/spi.h"

#define RESET_PIN 20

int main() {
	int i;
	uint8_t inputByte, byteReceived;
	// Initialize RESET output:
	gpio_init(RESET_PIN);
	gpio_put(RESET_PIN, 1);
	gpio_set_dir(RESET_PIN, GPIO_OUT);
	// Initialize SPI as master:
	spi_init(spi_default, 1000);
	spi_set_format(spi_default, 8, SPI_CPOL_0, SPI_CPHA_0, SPI_MSB_FIRST);
    gpio_set_function(PICO_DEFAULT_SPI_RX_PIN, GPIO_FUNC_SPI);
    gpio_set_function(PICO_DEFAULT_SPI_SCK_PIN, GPIO_FUNC_SPI);
    gpio_set_function(PICO_DEFAULT_SPI_TX_PIN, GPIO_FUNC_SPI);
	// Initialize stdio module:
	stdio_init_all();
	// Wait a second and pull RESET low:
	sleep_ms(1000);
	gpio_put(RESET_PIN, 0);
	for(;;) {
		scanf("%2x", &i);
		inputByte = (uint8_t) i;
		printf("Sending %02x = %d to the AVR.\n", inputByte, inputByte);
		spi_write_read_blocking(spi_default, &inputByte, &byteReceived, 1);
		printf("Received %02x = %d from the AVR.\n\n", byteReceived, byteReceived);
	}
}
